=== debian/changelog ===
mediastreamer2 (1:2.16.1-4ubuntu2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:07:45 +0100

mediastreamer2 (1:2.16.1-4ubuntu1) eoan; urgency=medium

  * debian/patches/gcc-9-compatibility.patch: fix wrong uses of strncpy
    with off-by-one errors.  Closes: #925775.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 08 Aug 2019 09:08:09 -0700

mediastreamer2 (1:2.16.1-4build2) eoan; urgency=medium

  * No-change rebuild against libvpx6

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 08 Aug 2019 15:35:22 +0000

mediastreamer2 (1:2.16.1-4build1) disco; urgency=medium

  * No-change rebuild against latest glew

 -- Jeremy Bicha <jbicha@ubuntu.com>  Fri, 23 Nov 2018 19:58:16 -0500

mediastreamer2 (1:2.16.1-4) unstable; urgency=medium

  * Team upload.
  * Release to unstable

 -- Bernhard Schmidt <berni@debian.org>  Wed, 10 Oct 2018 23:04:34 +0200

mediastreamer2 (1:2.16.1-3) experimental; urgency=medium

  * Team upload.

  [ Dr. Tobias Quathamer ]
  * Switch Vcs-URLs to salsa.d.o
  * Add patch to fix possible breakage with FFmpeg 4.0.
    Thanks to James Cowgill <jcowgill@debian.org> (Closes: #901735)
  * Use debhelper v11
  * Update Standards-Version to 4.1.4, no changes needed

  [ Bernhard Schmidt ]
  * Switch to libsrtp2, cherry-picking an upstream commit
  * Fix FTBFS with GCC-8 (cherry-pick two upstream commits) (Closes: #905481)
  * remove superfluous libmediastreamer-dev.docs

 -- Bernhard Schmidt <berni@debian.org>  Wed, 03 Oct 2018 22:08:36 +0200

mediastreamer2 (1:2.16.1-2) experimental; urgency=medium

  * Team upload.
  * Use DEB_LDFLAGS_MAINT_APPEND instead of DEB_LDFLAGS_APPEND

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 18 Nov 2017 12:13:07 +0100

mediastreamer2 (1:2.16.1-1) experimental; urgency=medium

  * Team upload.

  [ Felix Lechner ]
  * Initial release separate from linphone (Closes: #787150)

  [ Johannes 'josch' Schauer ]
  * New upstream version 2.15.1
    - Update build dependencies
    - Switch from autotools to CMake (upstream deprecated autotools)
    - debian/patches/fix-spelling-errors.patch: fix more spelling mistakes
  * debian/control: drop *-dbg packages in favour of automatically
    generated *-dbgsym packages
  * debian/compat: Bump debhelper compatibility level to 10
  * debian/control: bump Standards-Version (no changes required)
  * debian/rules: Use hardening=+all
  * Remove debian/libmediastreamer-voip9.lintian-overrides because
    there is no embedded library anymore
  * Unify libmediastreamer-base-dev and libmediastreamer-voip-dev into
    libmediastreamer-dev. linphone is the only user of the package and
    there is no reason to split them.

  [ Dr. Tobias Quathamer ]
  * New upstream version 2.16.1
    - Refresh patches
    - Add libxml2-dev to Build-Depends
    - Create the needed gitversion.h file
  * Use HTTPS URLs
  * Bump library .so name from 9 to 10
  * Remove unneeded script mkdeb.sh
  * Update Standards-Version to 4.1.1
  * Remove unneeded lintian override for source package
  * Add new library symbols
  * Add -Wl,--as-needed to DEB_LDFLAGS_APPEND

 -- Dr. Tobias Quathamer <toddy@debian.org>  Thu, 16 Nov 2017 22:59:17 +0100
