=== debian/control ===
Source: mediastreamer2
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Mark Purcell <msp@debian.org>,
           Kilian Krause <kilian@debian.org>,
           Tzafrir Cohen <tzafrir@debian.org>,
           Felix Lechner <felix.lechner@gmail.com>,
Build-Depends: cmake (>= 3.0),
               debhelper (>= 11),
               doxygen,
               gettext,
               graphviz,
               intltool,
               libasound2-dev [linux-any],
               libavcodec-dev (>= 6:10~),
               libavutil-dev (>= 6:10~),
               libbctoolbox-dev,
               libbzrtp-dev (>= 1.0.5),
               libcunit1-ncurses,
               libebml-dev,
               libglew-dev,
               libgsm1-dev,
               libltdl-dev,
               libmbedtls-dev,
               libogg-dev,
               libopus-dev,
               libortp-dev (>= 1:1.0.0),
               libpcap-dev,
               libpulse-dev,
               libsdl1.2-dev,
               libspandsp-dev,
               libspeex-dev,
               libspeexdsp-dev,
               libsrtp2-dev [!hurd-any !sparc],
               libswscale-dev (>= 6:10~),
               libtheora-dev,
               libturbojpeg0-dev,
               libupnp-dev,
               libv4l-dev [linux-any],
               libvpx-dev,
               libx11-dev,
               libxext-dev,
               libxml2-dev,
               libxv-dev,
               mesa-common-dev,
               pkg-config,
               xxd,
Standards-Version: 4.1.4
Section: libs
Homepage: https://www.linphone.org/technical-corner/mediastreamer2/overview
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/mediastreamer2
Vcs-Git: https://salsa.debian.org/pkg-voip-team/mediastreamer2.git

Package: libmediastreamer-base10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Voice and video streaming engine for telephony (base)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains the base library.

Package: libmediastreamer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmediastreamer-base10 (= ${binary:Version}),
         libmediastreamer-voip10 (= ${binary:Version}),
         ${misc:Depends},
Description: Development files for the mediastreamer2 library
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains the development files for the development library.

Package: libmediastreamer-voip10
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Breaks: libmediastreamer-base4 (<< 1:2.16.1),
Replaces: libmediastreamer-base4 (<< 1:2.16.1),
Description: Voice and video streaming engine for telephony (voip)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains the voip library.
