=== debian/watch ===
version=3

opts=\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/mediastreamer2-$1\.tar\.gz/,\
  https://github.com/BelledonneCommunications/mediastreamer2/tags .*/v?(\d\S*)\.tar\.gz
